// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Handle add/remove competency links.
 *
 * @module     format_iena/suivi-table
 * @package    format_iena
 * @copyright  2021 Myriam Delaruelle
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define(['jquery'],
       function($) {
       	var all_selected=false;
        nb_results=$("#table-body input").length;
        $("#select-actions-suivi-iena").prop("disabled", true);
       	return{
          
       		registerSelectAll:function(){
       			all_selected=false;
            if(!$._data( $('#iena-select-all')[0], 'events' )){
         			$('#iena-select-all').on('click', function(e){
  					     select_all_studs(e);
  	    		  });
              $(".checkstudent").on("click", function(){
                checkSelectActions();
              })
            }
       		}
       	}

   
    function select_all_studs(e) {
  		all_selected=!all_selected;
  		var counter = 0;
  		var checks = document.querySelectorAll("#table-body tr");
  		for (var i = 0; i < checks.length; i++) {
  			if ( checks[i].style.display != "none" || all_selected ) {
  				var box = checks[i].querySelector("input[type='checkbox']");
  				box.checked = all_selected;
  				counter++;
  			}
  		}
        checkSelectActions();
	}

      function checkSelectActions(){
        var selectedChecks=$("#table-body input:checked");
        if($("#select-actions-suivi-iena").prop("disabled") == false){
            
            
            if(selectedChecks.length==0){
                $("#select-actions-suivi-iena").prop("disabled", true);
            }
        }
        else{
            $("#select-actions-suivi-iena").prop("disabled", false);
        }
        $("#count-selected-students").text(selectedChecks.length+" résultat(s) sélectionné(s) sur "+nb_results);
    }





});
