<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
/**
 * format_iena
 *
 * @package    format_iena
 * @copyright  2018 Softia/Université lorraine
 * @author     vrignaud camille
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die();

$string['pluginname'] = 'Format de cours avec suivi avancé des activités';
$string['currentsection'] = 'La section';
$string['editsection'] = 'Modifier section';
$string['deletesection'] = 'Supprimer section';
$string['sectionname'] = 'Section';
$string['section0name'] = 'Général';
$string['hidefromothers'] = 'Cacher section';
$string['showfromothers'] = 'Voir section';
$string['showdefaultsectionname'] = 'Show the default sections name';
$string['showdefaultsectionname_help'] = 'If no name is set for the section will not show anything.<br>
By definition an unnamed section is displayed as <strong>section [N]</strong>.';
$string['yes'] = 'Oui';
$string['no'] = 'Non';
$string['sectionposition'] = 'Section zero position';
$string['name'] = 'Nom';
$string['summary'] = 'Résumé';
$string['modalite'] = 'Modalité';
$string['notif'] = 'Notification';
$string['notif_summary'] = 'Une notification peut être envoyée à l étudiant par mail. Elle lui rapplera de consulter la section et contiendra diverses informations (nom du cours, lien vers le cours, nom de la section, date le la section et modalité';
$string['in_presence'] = 'Session en présence';
$string['not_presence'] = 'Session à distance';
$string['days_before'] = 'Un certain nombre de jours avant la séance';
$string['days_after'] = 'Un certain nombre de jours après la séance';
$string['days_same'] = 'Le jour même';
$string['nb_days_before'] = 'jours avant';
$string['nb_days_after'] = 'jours après';
$string['hide_section'] = 'Cacher la section';
$string['hide_section_summary'] = 'Restreindre l\'accès à la séance et la cacher avant une certaine date';
$string['hide_option_1'] = 'Ne pas restreindre l\'accès avant une date';
$string['hide_option_2'] = 'Avant la date de la séance';
$string['hide_option_3'] = 'Avant la date de la notification';
$string['hide_bread_crum'] = 'Afficher la barre de progression';
$string['hide_icon_message'] = 'Afficher l\'icone messagerie';
$string['modules_for'] = 'Activités suivies pour';
$string['all_course'] = 'Tout le Cours';
$string['students'] = 'Etudiants';
$string['not_done'] = 'n\'ayant pas tout achevé';
$string['all_students'] = 'tous les étudiants';
$string['student'] = 'Eleve';
$string['send_message'] = 'Envoyer un message';
$string['for_section_select'] = 'Pour la section sélectionnée, vous aurez un indicateur du nombre d\'étudiant qui n\'ont pas achevé les activités ci-dessous.';
$string['cancel'] = 'Annuler';
$string['save'] = 'Enregistrer';
$string['check_completion'] = 'Surveiller l\'achèvement';
$string['indic_suivi'] = 'Indicateurs de suivi de la section';
$string['form_not_defined'] = 'Non renseigné';
$string['settings_section_form'] = 'Paramètre de la section';
$string['course'] = 'Cours';
$string['link'] = 'Lien';
$string['prof'] = 'Professeur';
$string['section'] = 'Section';
$string['hide_section'] = 'CACHER la section ';
$string['show_section'] = 'MONTRER la section ';
$string['aboutcourse'] = 'À propos de ce cours';
$string['modalite_help'] = 'La modalité "Distance" vous permettra de définir une date de séance et des notifications x jours avant la séance. La modalité "Présentiel" vous permettra de définir une date pour un rendu, et des notifications x jours avant la date de rendu';
$string['loadingResults'] = "Chargement des résultats...";
$string['errorLoadingResults'] = "Les étudiants n'ont pas pu être chargés, veuillez contacter un administrateur.";
$string['caption'] = "Légende";
$string['status0'] = "Activité non complétée";
$string['status1'] = "Activité complétée";
$string['status2'] = "Activité complétée et validée";
$string['status3'] = "Activité complétée non validée";
$string["send_message_title"] = "Envoi d'un message à {{nb_results}} personnes";
$string['display_course_infos'] = "Afficher/Masquer les informations du cours";
$string['my_progress'] = "Ma progression dans le cours : ";
$string['table_progress'] = "Suivi des étudiants";
$string['displayInfos'] = "Afficher les infos du cours";
$string['hideInfos'] = "Masquer les infos du cours";
$string['message_pres'] = "Message présentiel";
$string['message_default_pres'] = "Entrez ici le message qui sera envoyé à vos étudiants";
$string['message_pres_desc'] = "Paramétrez le message qui sera envoyé par défaut pour un cours en présentiel";
$string['message_dist'] = "Message distanciel";
$string['message_dist_desc'] = "Paramétrez le message qui sera envoyé par défaut pour un cours à distance";
$string['message_default_dist'] = "Entrez ici le message qui sera envoyé à vos étudiants";
$string['formatenabled']="L'achèvement de cours n'est pas activé. Vous pouvez l'activer dans la section \"Achèvement de cours\" des paramètres du cours : ";
$string['selectedActivities']="sélectionnée(s)";
$string['allActivities']="Toutes";
$string['display_groups']="Afficher les groupes dans une colonne du tableau";
$string['display_custom']="Activer la personnalisation du tableau";
$string['display_details']="Afficher les détails d'une activité évaluée au clic";
$string['display_status']="Activer le statut \"En attente d'évaluation de ma part\"";
$string['display_groups_help']="Cette option ajoute une colonne dans le tableau contenant le nom du groupe de l'étudiant.";
$string['display_custom_help']="Cette option active la personnalisation du tableau et permet d'ajouter des couleurs à certaines activités (personnel), ou de définir des jalons (pour tous les enseignants du cours)";
$string['display_details_help']="Cette option permet à l'enseignant d'avoir les détails d'une évaluation au clic : note, date de l'évaluation, évaluateur...";
$string['display_status_help']="Cette option ajoute un statut 'En attente d'évaluation de ma part qui permet de repérer quelles activités ont été complétées par l'étudiant et nécessite une action de la part de l'enseignant";
$string['enable_icon_click']="Activer les pastilles cliquables";
$string['enable_icon_click_help']="Par défaut, les étudiants peuvent accéder directement aux activités en cliquant sur leur pastille dans leur interface de progression. Vous pouvez désactiver ces liens pour que les étudiants ne puissent pas accéder aux ressources en dehors d'un certain contexte.";