<?php


global $CFG;
require_once($CFG->dirroot. '\course\format\iena\classes\form\edittable_form.php');



class my_test extends \advanced_testcase {

    public function test_get_array_options(){
        global $DB, $CFG;
        $this->resetAfterTest(true);
        $olddebug = $CFG->debug;
        $CFG->debug = 0;
        $generator = $this->getDataGenerator();
        $course1 = $generator->create_course();
        $course2 = $generator->create_course();
        $data=[
            "option1"=>[
                "option"=>"display_groups",
                "value"=>"1",
                "courseid"=>$course1->id,
                "userid"=>"1",
            ],
            "option2"=>[
                "option"=>"display_custom",
                "value"=>"1",
                "courseid"=>$course1->id,
                "userid"=>"1",
            ],
            "option3"=>[
                "option"=>"display_details",
                "value"=>"1",
                "courseid"=>$course1->id,
                "userid"=>"1",
            ],
            "option4"=>[
                "option"=>"display_status",
                "value"=>"1",
                "courseid"=>$course2->id,
                "userid"=>"1",
            ]
        ];
         // Create a set of options for the table.
         
        foreach($data as $x => $i){
            $obj=new \format_iena\output\course_format_iena_table_option(null, 0, $i["courseid"], $i["userid"]);
            $arrayoptionsid=$obj->save_property($i["option"], $i["value"]);
        }
        $arrayoptions=$obj->get_options_by_course_id($course1->id);
        
        $this->assertCount(3, $arrayoptions);
        $arrayoptions2=$obj->get_options_by_course_id($course2->id);
        
        $this->assertCount(1, $arrayoptions2);
        
        $CFG->debug = $olddebug;

        

    }


	public function test_create_option() {
        global $DB, $CFG;
        $this->resetAfterTest(true);

        $olddebug = $CFG->debug;
        $CFG->debug = 0;


        $data=[
            "option"=>\format_iena\output\course_format_iena_table_option::DISPLAY_GROUPS,
            "value"=>"1",
            "courseid"=>"1",
            "userid"=>"1",
        ];
         // Create a set of options for the table.
        $obj=new \format_iena\output\course_format_iena_table_option($data["option"], $data["value"], $data["courseid"], $data["userid"]);
        

        $arrayoptionsid=$obj->create_array_option();
        // Check the preset data.
        
        $arrayoptions = $DB->get_record('format_iena_options', ['id' => $arrayoptionsid]);

      
        $this->assertEquals($data["option"], $arrayoptions->optionname);
        $this->assertEquals($data["value"], $arrayoptions->optionvalue);
        $this->assertEquals($data["courseid"], $arrayoptions->courseid);
        $this->assertEquals($data["userid"], $arrayoptions->userid);

    
        $CFG->debug = $olddebug;
    }

    public function test_update_option(){

        global $DB, $CFG;
        $this->resetAfterTest(true);

        $olddebug = $CFG->debug;
        $CFG->debug = 0;
        $obj=new \format_iena\output\course_format_iena_table_option();
        $data=[
            "option"=>$obj::DISPLAY_GROUPS,
            "value"=>"1",
            "courseid"=>"1",
            "userid"=>"1",
        ];
         // Create a set of options for the table.
       
        
        $obj->setCourseId($data["courseid"]);
        $obj->setUserId($data["userid"]);
        $arrayoptionsid=$obj->save_property($data["option"], $data["value"]);
        // Check the preset data.
        
        $arrayoptions = $DB->get_record('format_iena_options', ['id' => $arrayoptionsid]);
        $this->assertEquals($data["option"], $arrayoptions->optionname);
        $this->assertEquals($data["value"], $arrayoptions->optionvalue);
        $this->assertEquals($data["courseid"], $arrayoptions->courseid);
        $this->assertEquals($data["userid"], $arrayoptions->userid);

        $this->assertNull($arrayoptions->timemodified);

        $arrayoptionsid2=$obj->save_property($data["option"], 0, $arrayoptionsid);
  
        $arrayoptionsupdated = $DB->get_record('format_iena_options', ['id' => $arrayoptionsid]);

        $this->assertEquals($data["option"], $arrayoptionsupdated->optionname);
        $this->assertEquals(0, $arrayoptionsupdated->optionvalue);
        $this->assertEquals($data["courseid"], $arrayoptionsupdated->courseid);
        $this->assertEquals($data["userid"], $arrayoptionsupdated->userid);

        $this->assertEquals($arrayoptions->timecreated, $arrayoptionsupdated->timecreated);
        $this->assertNotNull($arrayoptionsupdated->timemodified);

        $CFG->debug = $olddebug;
    	
    }

    public function test_uncheck_option(){

        global $DB, $CFG;
        $this->resetAfterTest(true);

        $olddebug = $CFG->debug;
        $CFG->debug = 0;
        $obj=new \format_iena\output\course_format_iena_table_option();
        $data=[
            "option"=>$obj::DISPLAY_GROUPS,
            "value"=>"1",
            "courseid"=>"1",
            "userid"=>"1",
        ];
        $data2=[
            "option"=>"display_custom",
            "value"=>"1",
            "courseid"=>"1",
            "userid"=>"1",
        ];
         // Create a set of options for the table.
       
        
        $obj->setCourseId($data["courseid"]);
        $obj->setUserId($data["userid"]);
        $idoptiongroup=$obj->save_property($data["option"], $data["value"]);
        // Check the preset data.
        
        $idoptioncustom=$obj->save_property($data2["option"], $data2["value"]);
       // fwrite(STDERR, print_r($arrayoptionsid2, TRUE));
       $arrayrequest=$DB->get_records('format_iena_options',["courseid"=>1]);
        $arrayoptions=$obj->get_request_options();


        $this->assertCount(2, $arrayrequest);
        $this->assertEquals($arrayoptions[$obj::DISPLAY_GROUPS]["id"], $idoptiongroup);
        $this->assertEquals($arrayoptions[$obj::DISPLAY_CUSTOM]["id"], $idoptioncustom);
        


        $listoptions=$obj->get_list_options();
        $arraycustomform=$arrayoptions;
        $arraycustomform["courseid"]=1;
        
        // Instantiate a form to submit.
        $values=[
            $obj::DISPLAY_GROUPS=>1,
            $obj::DISPLAY_CUSTOM=>0
        ];

        // Fetch the data and then mock the submission of that data.
        
        edittable_form::mock_submit($values);

        $mform= new edittable_form(null, $arraycustomform);
        $this->assertTrue($mform->is_validated());
        // The `get_data()` function will return the validated data, plus any defaults.
        $actualfromform = $mform->get_data();
        $obj->check_options_state($actualfromform);
        $arrayrequest=$DB->get_records('format_iena_options',["courseid"=>1, "optionvalue"=>1]);
        $arrayrequestall=$DB->get_records('format_iena_options',["courseid"=>1]);

        $this->assertCount(1, $arrayrequest);
        $this->assertEquals($arrayrequest[$idoptiongroup]->optionname, $obj::DISPLAY_GROUPS);
        $this->assertCount(2, $arrayrequestall);
        $this->assertEquals($arrayrequestall[$idoptioncustom]->optionname, $obj::DISPLAY_CUSTOM);
        $this->assertEquals($arrayrequestall[$idoptioncustom]->optionvalue, $values[$obj::DISPLAY_CUSTOM]);
        $CFG->debug = $olddebug;
        
    }

    /*public function create_options_provider(): array {
        return [
            'Full preset' => [
                'name' => 'Full',
                'comments' => null,
                'author' => null,
                'applypreset' => false,
                'iscore' => manager::FULL_PRESET,
                'iscoreresult' => manager::FULL_PRESET,
            ],
            'Invalid iscore' => [
                'name' => 'Invalid iscore value',
                'comments' => null,
                'author' => null,
                'applypreset' => false,
                'iscore' => -1,
                'iscoreresult' => manager::NONCORE_PRESET,
            ],
        ];
    }*/




}