<?php

class view_course_header {

	private $_content = "";

	public function __construct($section_names, $idSection, $course, $progress = false) {

		global $CFG;

		$this->section_names = $section_names;
		$this->idSection = $idSection;
		// $this->completion_total = $completion_total;
		$this->course = $course;
		//$this->create_view($progress);
	}

	/**
	 * Description
	 * @param type $progress 
	 * @return type
	 */
	public function create_view($progress) {
		// $this->get_progress_bis($this->section_names, $this->idSection, $this->course);
		$prog = $progress != false ? $progress : $this->get_progress_bis($this->section_names, $this->idSection, $this->course);
		//var_dump($prog);
	
		//var_dump($prog_test);
		$infos = [
			'progress' => $prog,
			'teachers' => $this->get_teachers(),
			//'groups' => $this->get_groupes(),
			// 'attendance' => $this->get_attendance_link()
		];
		
		return $this->get_data($infos);
	}

	private function get_progress_bis($section_names, $idSection, $course) {

		global $COURSE, $USER, $DB, $CFG;
		
		$completion = new \completion_info($COURSE);
		if ( $completion->is_enabled_for_site() == false || $completion->has_activities() == false || $completion->is_enabled() == 0 ) {
			return false;
		}

		$sections = [];

		$fast_modinfo = get_fast_modinfo($course->id);
		$modinfos_cms = $fast_modinfo->get_cms();

		$modules = [];
		foreach ($modinfos_cms as $cm) {
			$module = $completion->get_data($cm, true, $USER->id, $fast_modinfo);
			$module->url = "$CFG->wwwroot/mod/$cm->modname/view.php?id=$cm->id";
			$module->section = $cm->section;
			if ( $cm->deletioninprogress == 0 && $cm->completion != 0 ) {
				$modules[] = $module;
			}
		}



		$total_completed = 0;
		$total_modules = 0;
		foreach ($idSection as $i => $section_id) {
			$section = new StdClass();
			$section->id = $i;
			$section->name = $section_names[$i];
			$inner_modules = [];
			$inner_completed = 0;
			foreach ($modules as $module) {
				if ( $module->section == $section_id ) {
					$mod = new StdClass();
					$mod->coursemoduleid = $module->coursemoduleid;
					$mod->completion = $module->completionstate;
					if ( $mod->completion == 1 || $mod->completion == 2 ) {
						$inner_completed++;
					}
					foreach ($modinfos_cms as $cm) {
						if ( $cm->id == $mod->coursemoduleid ) {
							$mod->name = $cm->name;
							$mod->url = "$CFG->wwwroot/mod/$cm->modname/view.php?id=$cm->id";
						}
					}
					$inner_modules[] = $mod;
				}
			}
			$section->modules = $inner_modules;
			if ( count($inner_modules) == 0 ) {
				$section->completion = 0;
			} else {
				$section->completion = number_format( 100 * $inner_completed / count($inner_modules), 0 );
			}
			$total_completed += $inner_completed;
			$total_modules += count($inner_modules);
			array_push($sections, $section);
		}

		$progress = new StdClass();
		$progress->total = number_format( 100 * $total_completed / $total_modules, 0);
		$progress->sections = $sections;

		// echo "<pre>";
		// var_dump($progress);
		// echo "</pre>";

		return $progress;

	}

	// private function get_progress($section_names, $idSection, $completion_total) {
	// 	global $COURSE, $USER;

	// 	/* L'achèvement d'activité est activé dans le cours */
	// 	$completion = new \completion_info($COURSE);
	// 	if ( $completion->is_enabled() == 0 ) { return false; }

	// 	/* L'affichage de la complétion est activé dans les paramètres du format de cours */
	// 	$course_params = course_get_format($COURSE->id)->get_course();
	// 	$show_progress = $course_params->viewbreadcrum == 1 ? true : false;
	// 	if ( ! $show_progress ) { return false; }

	// 	$ressources_entity = new course_format_iena_section_ressources();
	// 	$section_entity = new course_format_iena_sections();
	// 	$completions = $ressources_entity->get_completions_by_userid($USER->id, $COURSE->id);
	// 	$modinfo = get_fast_modinfo($COURSE->id);
	// 	$progress = array();
	// 	$content = false;
	// 	$i = 0; // initialement = 1 mais pb avec la section 0
	// 	$total_modules = 0;
	// 	$total_completed_modules = 0;
	// 	$s_it = 0;
	// 	$progress['sections'] = [];
	// 	foreach ($section_entity->get_sections_by_id_course($COURSE->id) as $key => $section) {
	// 		// if ( $section->section == 0 ) {
	// 		// 	continue;
	// 		// }
	// 		if ($section_names[$i]) {
	// 			$sec_name = $section_names[$i];
	// 			$date_section = $section_entity->get_section_settings_by_id_section($idSection[$i]);
	// 			$chaine = mb_strimwidth($section_names[$i], 0, 20, "...");
	// 			$completion_by_section = $this->get_completion_by_section($idSection[$i]);
	// 			$section_modules = $completion_by_section[0];
	// 			$compl_by_section = $completion_by_section[1];
	// 			if ( $compl_by_section != 999 ) {
	// 				$total_modules += count($section_modules);
	// 				$pourcentage_section = $compl_by_section;
	// 			} else {
	// 				$pourcentage_section = 0;
	// 			}
	// 			if (floor($pourcentage_section) >= 100) {
	// 				$couleur = "done";
	// 			} else {
	// 				$couleur = "done";
	// 			}
	// 			$completion_ok = 0;
	// 			$completion_encours = 0;
	// 			$completion_pasfait = 0;
	// 			$modules = array();
	// 			foreach ($modinfo->get_cms() as $cm) {
	// 				$in_modules = false;
	// 				foreach ($section_modules as $mod) {
	// 					if ($mod->id == $cm->id) {
	// 						$in_modules = true;
	// 					}
	// 				}
	// 				if ($cm->section == $idSection[$i] && $cm->completion != 0 && $cm->deletioninprogress == 0 && $in_modules) {
	// 					$dateUp = date_create($date_section->date_rendu);
	// 					if ($date_section->date_rendu) {
	// 						$date1 = $dateUp->getTimestamp();
	// 						$date2 = date_create(date("Y-m-d H:i:s"))->getTimestamp();
	// 						$nbJoursTimestamp = $date1 - $date2;
	// 						$nbJours = $nbJoursTimestamp / 86400;
	// 					} else {
	// 						$nbJours = 0;
	// 					}
	// 					$color = "";
	// 					foreach ($completions as $completion) {
	// 						if ($completion->coursemoduleid == $cm->id && $completion->completionstate != 0) {
	// 							$completion_ok++;
	// 							$total_completed_modules++;
	// 							$color = "done";
	// 							break;
	// 						}
	// 					}
	// 					if ($color == "") {
	// 						if ($nbJours > 0) {
	// 							$color = "todo";
	// 							$completion_pasfait++;
	// 						} else if ($nbJours < 0) {
	// 							$color = "late";
	// 							$completion_encours++;
	// 						} else {
	// 							$color = "todo";
	// 							$completion_pasfait++;
	// 						}
	// 					}
	// 					if ($section_modules !== 0) {
	// 						array_push($modules, [
	// 							'name' => $cm->name,
	// 							'link' => $cm->url,
	// 							'completion' => $color
	// 						]);
	// 					}
	// 				}
	// 			}
	// 		}
	// 		array_push($progress['sections'], [
	// 			'name' => $sec_name,
	// 			'id' => $i,
	// 			'completion' => floor($pourcentage_section),
	// 			'modules' => $modules
	// 		]);
	// 		$i++;
	// 		$s_it++;
	// 	}
	// 	if ($total_modules > 0) {
	// 		$progress["total"] = floor($total_completed_modules*100/$total_modules);
	// 	} else {
	// 		$progress["total"] = false;
	// 	}
	// 	$content .= "</div>";

	// 	// echo "<pre>";
	// 	// var_dump($progress);
	// 	// echo "</pre>";

	// 	return $progress;

	// }

	/*31/03/2023 : Useless
	private function get_completion_by_section($idSection) {
		global $COURSE, $USER;
		$ressources_entity = new course_format_iena_section_ressources();
		$section_entity = new course_format_iena_sections();
		$modules = $ressources_entity->get_ressources_completion_on_by_id_section($idSection);
		$nb_modules = count($modules);
		if ($nb_modules == 0) {
			return array($nb_modules, 999);
		}
		$valueI = 100 / $nb_modules;
		$valueTotal = 0;
		foreach ($modules as $module) {
			$complet = $ressources_entity->get_completions_by_module($USER->id, $COURSE->id, $module->id);
			if ($complet->completionstate != 0) {
				$valueTotal += $valueI;
			}
		}
		return array($modules, $valueTotal);
	}*/

	private function get_teachers() {
		global $COURSE, $CFG, $USER;
		$course_params = course_get_format($COURSE->id)->get_course();
		if ( $course_params->viewiconmessage == 0 ) {
			return false;
		}
		$course_ctx = context_course::instance($COURSE->id);
		$enrolled_users = get_enrolled_users($course_ctx);
		$teachers = [];
		foreach ($enrolled_users as $user) {
			if ($this->is_teacher($user)) {
				$teachers[] = $user;
			}
		}
		return $teachers;
	}

	private function is_teacher($user) {
		global $COURSE;
		$course_ctx = context_course::instance($COURSE->id);
		foreach (get_user_roles($course_ctx, $user->id) as $role) {
			if ($role->shortname == 'teacher' || $role->shortname == 'editingteacher') {
				return true;
			}
		}
		return false;
	}

	private function count_students(){
		$count = count_enrolled_users($COURSE->id);
		return $count;
	}

	private function get_groupes() {
		global $COURSE, $USER;
		if ( ! $this->is_teacher($USER) ) { return false; }
		$groups = groups_get_all_groups($COURSE->id);
		$array = [];
		foreach ($groups as $group) {
			$array[] = [
				'id' => $group->id,
				'name' => $group->name
			];
		}
		return $array;
	}


	/**
	 * Retourne un tableau d'informations : array progress_total, array progress_sections, bool student, string summary
	 * @param array of object $infos 
	 * @return array
	 */
	private function get_data($infos){
		global $CFG, $COURSE, $USER;
		$course_data=[];
		$course_data['student']=false;
		//if user is a student
		if(!has_capability('course/iena:suivi', $context = context_course::instance($COURSE->id), $USER->id) &&$infos["progress"]){
			$course_data['progress_total']=$infos['progress']->total;
			


			// PROGRESS TOTAL : total progression percentage
			if ( $infos['progress'] !== false && $infos['progress']->total !== false ) {
				
				
				$course_data['progress_sections']=[];
				// section progress total
				foreach ($infos['progress']->sections as $section) {
					if ( count($section->modules) > 0 ) {
						array_push($course_data['progress_sections'], $section);
					
					}
				}
			}
			else {
			
			}
			$course_data['student']=true;
		}

		$course_data['summary']=$COURSE->summary;

		return $course_data;
	}

	public function get_content() {
		return $this->_content;
	}

}

